#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

int globalMinus = 0;

struct node {
    int min, count, secondMin;
    ll sum;
    node(int mn, int count, ll sum, int secondMin): min(mn), count(count), sum(sum), secondMin(secondMin){}
};

vector<node> tree;

int getZero(node v) {
    if (v.min == 0) {
        return v.count;
    } else {
        return 0;
    }
}

node merge(node a, node b) {
    node ans = {0, 0, 0, (int)1e9 + 7};
    if (a.min == b.min) {
        ans.secondMin = min(a.secondMin, b.secondMin);
    } else {
        ans.secondMin = min(max(a.min, b.min), min(a.secondMin, b.secondMin));
    }
    ans.sum = a.sum + b.sum;
    if (a.min == b.min) {
        ans.min = a.min;
        ans.count = a.count + b.count;
    } else if (a.min < b.min) {
        ans.min = a.min;
        ans.count = a.count;
    } else {
        ans.min = b.min;
        ans.count = b.count;
    }
    return ans;
}


vector<int> finish;

void upd(int v, int l, int r, int pos, int val, int s) {
    if (l == r - 1) {
        if (val == 0) {
            finish[l] = 1;
        }
        tree[v] = {val, 1, s, val ? val : (int)1e9 + 7};
        return;
    }
    int m = (l + r) / 2;
    if (pos < m) {
        upd(v * 2, l, m, pos, val, s);
    } else {
        upd(v * 2 + 1, m, r, pos, val, s);
    }
    tree[v] = merge(tree[v * 2], tree[v * 2 + 1]);
}

ll getSum(int v, int l, int r, int ql, int qr) {
    if (ql <= l && qr >= r) {
        return tree[v].sum;
    }
    if (qr <= l || ql >= r) {
        return 0;
    }
    int m = (l + r) / 2;
    return getSum(v * 2, l, m, ql, qr) + getSum(v * 2 + 1, m, r, ql, qr);
}


int getZero(int v, int l, int r, int ql, int qr) {
    if (ql <= l && qr >= r) {
        return getZero(tree[v]);
    }
    if (qr <= l || ql >= r) {
        return 0;
    }
    int m = (l + r) / 2;
    return getZero(v * 2, l, m, ql, qr) + getZero(v * 2 + 1, m, r, ql, qr);
}

node getMin(int v, int l, int r, int ql, int qr) {
    if (ql <= l && qr >= r) {
        return tree[v];
    }
    if (qr <= l || ql >= r) {
        return node(1e9, 0, 0, 1e9);
    }
    int m = (l + r) / 2;
    auto a = getMin(v * 2, l, m, ql, qr);
    auto b = getMin(v * 2 + 1, m, r, ql, qr);
    return merge(a, b);
}

int getNonNll(node v) {
    if (v.min != 0) {
        return v.min;
    } else {
        return v.secondMin;
    }
}


void delMin(int v, int l, int r, int x, bool fl) {
    if (l == r - 1) {
        if (fl && getNonNll(tree[v]) == x + 1) {
            tree[v] = {0, 1, 0, (int)1e9 + 7};
            finish[l] = 1;
        } else if (getNonNll(tree[v]) == x) {
            tree[v] = {0, 1, 0, (int)1e9 + 7};
            finish[l] = 1;
        }
        return;
    }
    int m = (l + r) / 2;
    if (fl && getNonNll(tree[v * 2]) == x + 1) {
        delMin(2 * v, l, m, x, fl);
    } else if (getNonNll(tree[v * 2]) == x) {
        delMin(2 * v, l, m, x, fl);
    }
    if (fl && getNonNll(tree[v * 2 + 1]) == x + 1) {
        delMin(2 * v + 1, m, r, x, fl);
    } else if (getNonNll(tree[v * 2 + 1]) == x) {
        delMin(2 * v + 1, m, r, x, fl);
    }
    tree[v] = merge(tree[v * 2], tree[v * 2 + 1]);
}

void delMin(int v, int l, int r, int ql, int qr, int x, bool fl) {
    if (!(fl && getNonNll(tree[v]) == x + 1) && getNonNll(tree[v]) != x) {
        return;
    }
    if (ql <= l && qr >= r) {
        if (fl && getNonNll(tree[v]) == x + 1) {
            delMin(v, l, r, x, fl);
        } else if (getNonNll(tree[v]) == x) {
            delMin(v, l, r, x, fl);
        }
        return;
    }
    if (qr <= l || ql >= r) {
        return;
    }
    int m = (l + r) / 2;
    delMin(v * 2, l, m, ql, qr, x, fl);
    delMin(v * 2 + 1, m, r, ql, qr, x, fl);
    tree[v] = merge(tree[v * 2], tree[v * 2 + 1]);
}

int n;
int K = 0;

int findInSubTree(int v, int l, int r) {
    if (l == r - 1) {
        return l;
    }
    int m = (l + r) / 2;
    if (m - l - getZero(tree[v * 2]) > K) {
        return findInSubTree(v * 2, l, m);
    } else {
        K -= m - l - getZero(tree[v * 2]);
        return findInSubTree(v * 2 + 1, m, r);
    }
}

int findBorder(int v, int l, int r, int ql, int qr) {
    if (ql <= l && qr >= r) {
        if (r - l - getZero(tree[v]) <= K) {
            K -= r - l - getZero(tree[v]);
            return n;
        }
        return findInSubTree(v, l, r);
    }
    if (qr <= l || ql >= r) {
        return n;
    }

    int m = (l + r) / 2;
    int ind = findBorder(v * 2, l, m, ql, qr);
    if (ind != n) {
        return ind;
    } else {
        return findBorder(v * 2 + 1, m, r, ql, qr);
    }
}

int findBorder(int left, int C) {
    int l = left, r = n;
    while (r - l > 1) {
        int m = (l + r) / 2;
        int cnt = m - left - getZero(1, 0, n, left, m);
        if (cnt >= C) {
            r = m;
        } else {
            l = m;
        }
    }
    return r;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    cin >> n;
    vector<ll> c(n), w(n);
    vector<pair<ll, int>> cSort(n);
    tree.resize(4 * n, node(1e9 + 7, 0, 0, 1e9 + 7));
    for (int i = 0; i < n; i++) {
        cin >> c[i] >> w[i];
        upd(1, 0, n, i, c[i], w[i]);
        cSort[i] = {c[i], i};
    }
    finish.resize(n);
    sort(cSort.begin(), cSort.end());
    int ind = 0;
    int shift = 0;
    for (int i = 0; i < n; i++) {
        int border = findBorder(shift, c[i]);
        int nonZeroPre = (border - shift) - getZero(1, 0, n, shift, border);
        ll sum = getSum(1, 0, n, shift, border);
        int C = c[i] - nonZeroPre;
        ll ans = sum;
        node mn = getMin(1, 0, n, shift, border);
        delMin(1, 0, n, shift, border, globalMinus, true);
        if (border == n) {
            globalMinus++;
        }
        shift = border % n;


        int nonZero = n - getZero(1, 0, n, 0, n);
        if (nonZero == 0) {
            cout << ans;
            break;
        }
        int cycle = C / nonZero;
        while (cycle) {
            sum = getSum(1, 0, n, 0, n);
            node mn = getMin(1, 0, n, 0, n);
            int nonZeroMin = mn.min;
            if (nonZeroMin == 0) {
                nonZeroMin = mn.secondMin;
            }

            cycle = min(cycle, nonZeroMin - globalMinus);
            globalMinus += cycle;
            C = C - nonZero * cycle;
            delMin(1, 0, n, 0, n, globalMinus, false);
            ans += cycle * sum;
            nonZero = n - getZero(1, 0, n, 0, n);

            if (nonZero == 0) {
                break;
            }
            cycle = C / nonZero;
        }
        if (C) {
            border = findBorder(shift, C);
            sum = getSum(1, 0, n, shift, border);
            ans += sum;
            delMin(1, 0, n, shift, border, globalMinus, true);
            if (border == n) {
                globalMinus++;
            }
            shift = border % n;
        }
        cout << ans << ' ';
    }

    return 0;
}