#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

int globalMinus = 0;

vector<int> mn, cnt, secondMin;
vector<ll> sum;


int getZero(int v) {
    if (mn[v] == 0) {
        return cnt[v];
    } else {
        return 0;
    }
}

void merge(int a, int b, int v) {
    if (mn[a] == mn[b]) {
        secondMin[v] = min(secondMin[a], secondMin[b]);
    } else {
        secondMin[v] = min(max(mn[a], mn[b]), min(secondMin[a], secondMin[b]));
    }
    sum[v] = sum[a] + sum[b];
    if (mn[a] == mn[b]) {
        mn[v] = mn[b];
        cnt[v] = cnt[a] + cnt[b];
    } else if (mn[a] < mn[b]) {
        mn[v] = mn[a];
        cnt[v] = cnt[a];
    } else {
        mn[v] = mn[b];
        cnt[v] = cnt[b];
    }
}


ll getSum(int v, int l, int r, int ql, int qr) {
    if (ql <= l && qr >= r) {
        return sum[v];
    }
    if (qr <= l || ql >= r) {
        return 0;
    }
    int m = (l + r) / 2;
    return getSum(v * 2, l, m, ql, qr) + getSum(v * 2 + 1, m, r, ql, qr);
}


int getZero(int v, int l, int r, int ql, int qr) {
    if (ql <= l && qr >= r) {
        return getZero(v);
    }
    if (qr <= l || ql >= r) {
        return 0;
    }
    int m = (l + r) / 2;
    return getZero(v * 2, l, m, ql, qr) + getZero(v * 2 + 1, m, r, ql, qr);
}

pair<int, int> getMin(int v, int l, int r, int ql, int qr) {
    if (ql <= l && qr >= r) {
        return {mn[v], secondMin[v]};
    }
    if (qr <= l || ql >= r) {
        return {1e9 + 7, 1e9 + 7};
    }
    int m = (l + r) / 2;
    auto a = getMin(v * 2, l, m, ql, qr);
    auto b = getMin(v * 2 + 1, m, r, ql, qr);
    return min(a, b);
}

int getNonNll(int v) {
    if (mn[v] != 0) {
        return mn[v];
    } else {
        return secondMin[v];
    }
}


void upd(int v, int l, int r, int pos, int val, int s) {
    if (l == r - 1) {
        mn[v] = val;
        cnt[v] = 1;
        sum[v] = s;
        secondMin[v] = val ? val : (int)1e9 + 7;
        return;
    }
    int m = (l + r) / 2;
    if (pos < m) {
        upd(v * 2, l, m, pos, val, s);
    } else {
        upd(v * 2 + 1, m, r, pos, val, s);
    }
    merge(v * 2, v * 2 + 1, v);
}

void delMin(int v, int l, int r, int x, bool fl) {
    if (l == r - 1) {
        if (fl && getNonNll(v) == x + 1) {
            mn[v] = 0;
            cnt[v] = 1;
            sum[v] = 0;
            secondMin[v] = (int)1e9 + 7;
        } else if (getNonNll(v) == x) {
            mn[v] = 0;
            cnt[v] = 1;
            sum[v] = 0;
            secondMin[v] = (int)1e9 + 7;
        }
        return;
    }
    int m = (l + r) / 2;
    if (fl && getNonNll(v * 2) == x + 1) {
        delMin(2 * v, l, m, x, fl);
    } else if (getNonNll(v * 2) == x) {
        delMin(2 * v, l, m, x, fl);
    }
    if (fl && getNonNll(v * 2 + 1) == x + 1) {
        delMin(2 * v + 1, m, r, x, fl);
    } else if (getNonNll(v * 2 + 1) == x) {
        delMin(2 * v + 1, m, r, x, fl);
    }
    merge(v * 2, v * 2 + 1, v);
}

void delMin(int v, int l, int r, int ql, int qr, int x, bool fl) {
    if (!(fl && getNonNll(v) == x + 1) && getNonNll(v) != x) {
        return;
    }
    if (ql <= l && qr >= r) {
        if (fl && getNonNll(v) == x + 1) {
            delMin(v, l, r, x, fl);
        } else if (getNonNll(v) == x) {
            delMin(v, l, r, x, fl);
        }
        return;
    }
    if (qr <= l || ql >= r) {
        return;
    }
    int m = (l + r) / 2;
    delMin(v * 2, l, m, ql, qr, x, fl);
    delMin(v * 2 + 1, m, r, ql, qr, x, fl);
    merge(v * 2, v * 2 + 1, v);
}

int n;
int K = 0;

int findInSubTree(int v, int l, int r) {
    if (l == r - 1) {
        return l;
    }
    int m = (l + r) / 2;
    if (m - l - getZero(v * 2) > K) {
        return findInSubTree(v * 2, l, m);
    } else {
        K -= m - l - getZero(v * 2);
        return findInSubTree(v * 2 + 1, m, r);
    }
}

int findBorder(int v, int l, int r, int ql, int qr) {
    if (ql <= l && qr >= r) {
        if (r - l - getZero(v) <= K) {
            K -= r - l - getZero(v);
            return n;
        }
        return findInSubTree(v, l, r);
    }
    if (qr <= l || ql >= r) {
        return n;
    }

    int m = (l + r) / 2;
    int ind = findBorder(v * 2, l, m, ql, qr);
    if (ind != n) {
        return ind;
    } else {
        return findBorder(v * 2 + 1, m, r, ql, qr);
    }
}

int findBorder(int left, int C) {
    K = C;
    return findBorder(1, 0, n, left, n);
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    cin >> n;
    vector<int> c(n), w(n);
    mn.resize(4 * n, 1e9 + 7);
    secondMin.resize(4 * n, 1e9 + 7);
    cnt.resize(4 * n, 0);
    sum.resize(4 * n, 0);
    for (int i = 0; i < n; i++) {
        cin >> c[i] >> w[i];
        upd(1, 0, n, i, c[i], w[i]);
    }
    
    int shift = 0;
    for (int i = 0; i < n; i++) {
        int border = findBorder(shift, c[i]);
        int nonZeroPre = (border - shift) - getZero(1, 0, n, shift, border);
        ll sum = getSum(1, 0, n, shift, border);
        int C = c[i] - nonZeroPre;
        ll ans = sum;
        delMin(1, 0, n, shift, border, globalMinus, true);
        if (border == n) {
            globalMinus++;
        }
        shift = border % n;


        int nonZero = n - getZero(1, 0, n, 0, n);
        if (nonZero == 0) {
            cout << ans;
            break;
        }
        int cycle = C / nonZero;
        while (cycle) {
            sum = getSum(1, 0, n, 0, n);
            pair<int, int> mn1 = getMin(1, 0, n, 0, n);
            int nonZeroMin = mn1.first;
            if (nonZeroMin == 0) {
                nonZeroMin = mn1.second;
            }

            cycle = min(cycle, nonZeroMin - globalMinus);
            globalMinus += cycle;
            C = C - nonZero * cycle;
            delMin(1, 0, n, 0, n, globalMinus, false);
            ans += cycle * sum;
            nonZero = n - getZero(1, 0, n, 0, n);

            if (nonZero == 0) {
                break;
            }
            cycle = C / nonZero;
        }
        if (C) {
            border = findBorder(shift, C);
            sum = getSum(1, 0, n, shift, border);
            ans += sum;
            delMin(1, 0, n, shift, border, globalMinus, true);
            if (border == n) {
                globalMinus++;
            }
            shift = border % n;
        }
        cout << ans << ' ';
    }

    return 0;
}