#include "testlib.h"

using namespace std;

pair<int, int> range(string const &opt_name) {
    auto items = split(opt<string>(opt_name), ",");
    return {atoi(items[0].c_str()), atoi(items[1].c_str())};
}

int randrange(string const &opt_name) {
    auto lim = range(opt_name);
    return rnd.next(lim.first, lim.second);
}

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), m = opt<int>("m");
    int p = has_opt("p") ? opt<int>("p") : randrange("p-rand");
    auto lim = range("a");
    auto op_pool = split(opt<string>("ops"), ",");

    int d = rnd.next(n);
    println(n, m, d, p);

    vector<int> a(n);
    for (int &ai : a) ai = rnd.next(lim.first, lim.second);
    println(a.begin(), a.end());

    vector<string> ops(m);
    for (string &op : ops) op = rnd.any(op_pool);
    println(ops.begin(), ops.end());

}