#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);
    int group = validator.group().size() ? atoi(validator.group().c_str()) : 0;

    int const A = 1000'000'000, T = 1000'000'000;
    // @formatter:off
    vector<int> Ag{A, 1000, A,      1, A, A};
    vector<int> Tg{T, 1000, 50'000, T, T, T};
    // @formatter:on

    int a = inf.readInt(1, Ag[group], "a");
    inf.readSpace();
    int b = inf.readInt(1, Ag[group], "b");
    inf.readSpace();

    int t = inf.readInt(1, Tg[group], "T");
    inf.readEoln();

    if (group == 4) {
        ensuref(a <= t, "group 4: a = %d, t = %d, a > t", a, t);
        ensuref(t <= b, "group 4: t = %d, b = %d, t > b", t, b);
        ensuref(b < 2 * a, "group 4: b = %d, a = %d, b > 2a", b, a);
    }

    inf.readEof();

}